//+------------------------------------------------------------------+
//|                                                            1.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
string Symb;                     //  . 
extern double StopLoss   =40;    // SL   
extern double TakeProfit =108;    //    
 int    Period_MA_1 =10;         //   1
 int    Period_MA_2 =60;         //   2
 int
    Ticket;                      //  
   // Lts =1.27;                      //  
   double
   SMA_1_0,                         // . _1 0 
   SMA_1_1,                         // . _1 1 
   SMA_2_0,                         // . _2 0 
   SMA_2_1,                         // . _2 1 
   SL,                              // SL   
   TP;                              // TP  

int LimitNumberOfTry = 3; //   
int Slippage = 3; //  
bool UseSound = True; //   
string NameFileSound = "expert.wav"; //   

#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  { 
  double Lts=MarketInfo(Symb,MODE_MINLOT);// .  
  Alert ("", Lts);
    RefreshRates();                        //  
 Symb=Symbol();   
 SMA_1_1=SMA_1_0;                          //  _1 1 
 SMA_2_1=SMA_2_0;                          //  _2 1 
 SMA_1_0=iMA(NULL,0,Period_MA_1,0,MODE_LWMA ,PRICE_TYPICAL,1); // _1 0 
 SMA_2_0=iMA(NULL,0,Period_MA_2,0,MODE_LWMA ,PRICE_TYPICAL,1); // _2  
 
//----
  if (SMA_1_0 > SMA_2_0 && SMA_1_1 < SMA_2_1 &&  SMA_2_1 + 10*Point == Bid)   //   
     {   
//      if (Ticket > 0)                           
         ClosePositions();                      //    - 
            //OrderClose(Ticket,Lts,Bid,10);       
         SL=Bid - StopLoss*Point;            //  SL .
         TP=Bid + TakeProfit*Point;            //  TP .
         Alert("  Buy.  ..");
         
         OpenPosition(Symbol(), OP_BUY, Lts, SL, TP);
//         Ticket=OrderSend(Symb,OP_BUY,Lts,Ask,3,SL,TP); // Buy
         if (Ticket > 0)                          //  :)
           {
            Alert ("  Buy ",Ticket);
            return;                               //   start()
           }
     }
//--------------------------------------------------------------------
   if (SMA_1_0 < SMA_2_0 && SMA_1_1 > SMA_2_1 && SMA_2_1 - 10*Point == Ask)   //   
     {
//      if (Ticket > 0)
         ClosePositions();
             //OrderClose(Ticket,Lts,Ask, 10);      //    
         SL=Ask + StopLoss*Point;              //  SL .
         TP=Ask - TakeProfit*Point;               //  TP .
         Alert("  Sell.  ..");
         OpenPosition(Symbol(), OP_SELL, Lts, SL, TP);
         //Ticket=OrderSend(Symb,OP_SELL,Lts,Bid,3,SL,TP);// Buy
         if (Ticket > 0)                        //  :)
           {
            Alert ("  Sell ",Ticket);
            return;                             //   start()
           }
        }
     
//---------
   return(0);
  }
  //+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :                                   |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sSymbol -     (""   -  ,              |
//|                                          NULL -  )            |
//|    iOperation -                 (-1   -  )             |
//|    iMagic - MagicNumber                 (-1   -  )               |
//+----------------------------------------------------------------------------+

void ClosePositions(string sSymbol = "", int iOperation = -1, int iMagic = -1) {
   int i, k = OrdersTotal();

   //if (sSymbol == "0") sSymbol = Symbol();
   for (i = k - 1; i >= 0; i--) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if ((OrderSymbol() == sSymbol || sSymbol == "") && (iOperation < 0 || OrderType() == iOperation)) {
            if (OrderType() == OP_BUY || OrderType() == OP_SELL) {
               if (iMagic < 0 || OrderMagicNumber() == iMagic) ClosePosBySelect();
            }
         }
      }
   }
}

//+----------------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
//|     :   . aka KimIV,  http://www.kimiv.ru                    |
//+----------------------------------------------------------------------------+
//|    : 13.06.2007                                                      |
//|  :                      |
//+----------------------------------------------------------------------------+
void ClosePosBySelect() {
  double pp;

  if (OrderType()==OP_BUY) {
    pp=MarketInfo(OrderSymbol(), MODE_BID);
    OrderClose(OrderTicket(), OrderLots(), pp, Slippage);
  }
  if (OrderType()==OP_SELL) {
    pp=MarketInfo(OrderSymbol(), MODE_ASK);
    OrderClose(OrderTicket(), OrderLots(), pp, Slippage);
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|    : 13.06.2007                                                      |
//|   :  .      .        |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     ("" -  )                   |
//|    op -                                                            |
//|    ll -                                                                 |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - MagicNumber                                                        |
//+----------------------------------------------------------------------------+
void OpenPosition(string sy, int op, double ll, double sl=0, double tp=0, int mn=0) {
  double pp;
  int    err, ticket;
 
  if (sy=="") sy=Symbol();
  if (op==OP_BUY) {
    pp=MarketInfo(sy, MODE_ASK);
  } else {
    pp=MarketInfo(sy, MODE_BID);
  }
  ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, "", mn, 0);
  if (ticket<0) {
    err=GetLastError();
    Print("Error(",err,") open ",GetNameOP(op),": ",ErrorDescription(err));
    Print("Ask=",Ask," Bid=",Bid," sy=",sy," ll=",ll,
          " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    iOperation -                               |
//+----------------------------------------------------------------------------+

string GetNameOP(int iOperation) {
   switch (iOperation) {
      case OP_BUY: return ("Buy");
      case OP_SELL: return ("Sell");
      case OP_BUYLIMIT: return ("Buy Limit");
      case OP_SELLLIMIT: return ("Sell Limit");
      case OP_BUYSTOP: return ("Buy Stop");
      case OP_SELLSTOP: return ("Sell Stop");
      default: return ("Unknown Operation");
   }
}